import scala.actors._
import Actor._

def getYearEndClosing(symbol : String, year : Int) = {
  val url = "http://ichart.finance.yahoo.com/table.csv?s=" +
    symbol + "&a=11&b=01&c=" + year + "&d=11&e=31&f=" + year + "&g=m"
    
  val data = io.Source.fromURL(url).mkString
  val price = data.split("\n")(1).split(",")(4).toDouble  
  (symbol, price)
}

val symbols = List("AAPL", "GOOG", "IBM", "ORCL", "MSFT")

val start = System.nanoTime
val caller = self

symbols.foreach { symbol => 
  actor { caller ! getYearEndClosing(symbol, 2009) }
}

val topStock = symbols.foldLeft(("", 0.0)) { (top, symbol) =>
  receiveWithin(1000) {
    case (sym: String, price: Double) =>
    if (top._2 < price)
     (sym, price)
    else
     top    
  }
}

val end = System.nanoTime

println("Top stock is " + topStock._1 + " at price $" + topStock._2)
println("Time taken is " + (end - start)/1000000000.0)